PROGRAM Reflex; { Turbo Pascal 6.0 }

USES  CRT,
      DOS,
      Fischer;

TYPE t_Reaction = RECORD
                    TestNo : INTEGER;
                    Time      : WORD;
                  END;

VAR Hour_1,Minute_1,Second_1,HndthSec_1,
    Hour_2,Minute_2,Second_2,HndthSec_2 : WORD;
    Delaytime                            : INTEGER;
    Inp_Outp_No,i,
    Test_ReactionNo                        : INTEGER;
    Time                                   : WORD;
    Reactionlist                         : ARRAY[1..10] OF t_Reaction;
    Name                                   : STRING;
    Programmend                           : BOOLEAN;
    Inpchar                                : CHAR;
    REALTime                               : REAL;

{}

PROCEDURE Name_Enter;
  BEGIN
    CLRSCR;
    gotoxy(10,5);
    writeln('R E F L E X  T E S T E R');
    gotoxy(10,10);
    WRITE('Name of player: ');
    READLN(Name);
    CLRSCR;
  END;
{}

PROCEDURE Test_Reaction;
  BEGIN
    Delaytime := RANDOM(10000);
    DELAY(Delaytime);
    Inp_Outp_No := RANDOM(3);
    IF Inp_Outp_No = 0 THEN Inp_Outp_No := 1;
    GETTIME(Hour_1,Minute_1,Second_1,HndthSec_1);
    Motor(Inp_Outp_No,ccw);
    REPEAT
      Motor(Inp_Outp_No,ccw);
    UNTIL NOT Switch(Inp_Outp_No);
    REPEAT
      Motor(Inp_Outp_No,ccw);
    UNTIL Switch(Inp_Outp_No);
    GETTIME(Hour_2,Minute_2,Second_2,HndthSec_2);
    Motor(Inp_Outp_No,off);
    Time :=  (Second_2 * 100 + HndthSec_2) - (Second_1 * 100 + HndthSec_1);
  END;
{}

PROCEDURE Time_Enter;
VAR i,j : INTEGER;
  BEGIN
    FOR i := 1 TO 10 DO
     BEGIN
       IF Time <= Reactionlist[i].Time
        THEN
         BEGIN
          FOR j := 10 DOWNTO i+1 DO Reactionlist[j] := Reactionlist[j-1];
          Reactionlist[i].Time := Time;
          Reactionlist[i].TestNo := Test_ReactionNo;
          EXIT;
         END;
     END;
  END;
{}

PROCEDURE Display;
VAR i : INTEGER;
  BEGIN
    CLRSCR;
    gotoxy(25,1);
    WRITELN('P L A Y E R : ',Name);
    REALTime := Time / 100;
    gotoxy(20,3);
    WRITELN('No. ',Test_ReactionNo:3);
    gotoxy(33,3);
    Writeln(' time:',REALTime:6:2,' sec');
    gotoxy(25,7);
    Writeln('T O P  T E N ');
    gotoxy(1,10);
    Writeln('!! B E S T !!');
    gotoxy(55,10);
    writeln('!! B E S T !!');

    FOR i := 1 TO 10 DO
     BEGIN
       GOTOXY(20,i+9);
       IF Reactionlist[i].TestNo <> 0
        THEN
         BEGIN
          REALTime := Reactionlist[i].Time / 100;

          WRITELN('No. ',Reactionlist[i].TestNo:3);
          gotoxy(33,i+9);
          writeln(' time:',REALTime:6:2,' sec');
         END
     END;
  END;
{}

BEGIN { Program Reflex }
  RANDOMIZE;
  Programmend    := FALSE;
  Test_ReactionNo := 0;
  FOR i := 1 TO 10 DO
    BEGIN
      Reactionlist[i].Time := 55555;
      Reactionlist[i].TestNo := 0;
    END;
  Name_Enter;
  REPEAT
    CLRSCR;
    GOTOXY(30,10);
    WRITELN('G E T  R E A D Y !');
    Delay(1000);
    gotoxy(30,12);
    Writeln('G E T  S E T !!');
    Delay(1000);
    gotoxy(30,14);
    writeln('G O !!!');
    INC(Test_ReactionNo);
    Test_Reaction;
    Time_Enter;
    Display;
    gotoxy(22,22);
    WRITELN('New Game ?   Y/N');
    Inpchar := UPCASE(READKEY);
    Programmend := Inpchar = 'N';
  UNTIL Programmend;
  clrscr
END.  { Program Reflex }
